import { CodegenGenerator, CodegenState, CodegenConfig } from '@openapi-generator-plus/types';
/**
 * Camel case and capitalize suitable for a class name. Doesn't change existing
 * capitalization in the value.
 * e.g. "FAQSection" remains "FAQSection", and "faqSection" will become "FaqSection"
 * @param value string to be turned into a class name
 */
export declare function classCamelCase(value: string): string;
export declare function identifierCamelCase(value: string): string;
export declare const enum ConstantStyle {
    allCapsSnake = "snake",
    allCaps = "allCaps",
    camelCase = "camelCase",
    pascalCase = "pascalCase"
}
export interface JavaLikeOptions {
    modelClassPrefix?: string;
    constantStyle: ConstantStyle;
}
export declare function options<O extends JavaLikeOptions>(config: CodegenConfig, context: JavaLikeContext<O>): JavaLikeOptions;
export interface JavaLikeContext<O extends JavaLikeOptions> {
    reservedWords?: (state: CodegenState<O>) => string[];
    defaultConstantStyle: ConstantStyle;
}
export declare function javaLikeGenerator<O extends JavaLikeOptions>(context: JavaLikeContext<O>): Pick<CodegenGenerator<O>, 'toClassName' | 'toIdentifier' | 'toConstantName' | 'toSchemaName' | 'toOperationGroupName'>;
